DEFINT I - K, M
DEFLNG L, N
DEFDBL D, P, T, V, X-Z
DEFSNG U

SUB CHNGATT (Il, Ir, Io, Iu, IScrAtt)
SHARED ISegFarbe, ISegOff
LOCAL I, J, IPosi

      DEF SEG = ISegFarbe
      FOR J = Io TO Iu
          FOR I = Il TO Ir
              IPosi = ISegOff + (J - 1) * 160 + (I - 1) * 2
              POKE IPosi + 1, IScrAtt
          NEXT I
      NEXT J

END SUB

SUB DELBLK (Text$)
LOCAL I, ILen, J, Tex$

      CALL LINKS(Text$)
      ILen = LEN(Text$)
      Tex$ = Text$
      I = 2
      FOR J = 2 TO ILen
          IF MID$(Text$, I, 1) = " " THEN
             Tex$ = MID$(Text$, 1, I - 1)
             IF ILen > I THEN
                Text$ = Tex$ + MID$(Text$, I + 1)
                Tex$ = Text$
             END IF
             DECR I
          END IF
          INCR I
      NEXT J
      Text$ = Tex$

END SUB

SUB DIRECTORY (Datei$, Pfad$, IDir, IEcho)
SHARED MaskSeg&, MaskOfs&, DTASeg&, DTAOfs&, FileN$(), IFin, IDTA(), IMask()
SHARED Upro$, DirTxt$, IFileMax

      Upro$ = "DIRECTORY"
      IF IDir = 1 THEN DIR10
      Datei$ = ""
      IFin = 0
      DTASeg& = VARSEG(IDTA(1))
      DTAOfs& = VARPTR(IDTA(1))
      MaskSeg& = VARSEG(IMask(1))
      MaskOfs& = VARPTR(IMask(1))
      CALL SETDTA(IFehl)
      CALL FIRSTFILEN(Pfad$, IFehl)
      CALL NEXTFILEN(IFehl)
      Upro$ = "DIRECTORY"
      IAnf = 1
      IDir = 1
      FileN$(IFin + 1) = "----Ende----"
      FOR I = IFin + 2 TO IFileMax
          FileN$(I) = ""
      NEXT I
      IF IEcho = 0 THEN EXIT SUB

DIR10:
      LOCATE 21, 26
      PRINT DirTxt$; TAB(58);
      CALL RAHMEN(65, 80, 5, 22, 1, 1)

DIR40:
      IF IAnf >= IFin THEN IAnf = IFin
      IF IAnf < 1 THEN IAnf = 1
DIR45:
      LOCATE 6, 66
      COLOR 8, 7
      PRINT FileN$(IAnf); TAB(80);
      COLOR 7, 8
      FOR I = 1 TO 15
          LOCATE 6 + I, 66
      PRINT FileN$(IAnf + I); TAB(80);
      NEXT I

DIR60:
      CALL PRESSKEY(Taste$)
      CALL SCAN(Taste$, Isc1, Isc2, Isc3)
      SELECT CASE Isc3
        CASE 1031
          CALL SPEICHERFREI
        CASE 1080
          IAnf = IAnf + 1
        CASE 1072
          IAnf = IAnf - 1
        CASE 1081
          IAnf = IAnf + 10
        CASE 1073
          IAnf = IAnf - 10
        CASE 1071
          IAnf = 1
          GOTO DIR45
        CASE 1079
          IAnf = IFin
        CASE 13
          Datei$ = FileN$(IAnf)
          GOTO DIR50
        CASE 27
          GOTO DIR50
        CASE ELSE
          GOTO DIR60
      END SELECT
      GOTO DIR40
DIR50:
      CALL LOESCHEN(65, 80, 5, 22)

END SUB

SUB EDITSCREEN (ILen, Fld$, Isc, Zz$, ICurs)
SHARED Insert, Ins$(), IVor, IHin
SHARED Upro$
LOCAL Z1$

       Upro$ = "EDITSCREEN"

       IF Isc < 1000 THEN EDI10

       SELECT CASE Isc
          CASE 1083                       ' Zeichen entfernen
             IF ICurs = 0 THEN
                Fld$ = MID$(Fld$, 2) + " "
             ELSE
                Fld$ = MID$(Fld$, 1, ICurs) + MID$(Fld$, ICurs + 2) + " "
             END IF
             EXIT SUB
          CASE 1082                       ' Insert - Schalter
            COLOR 7 + Insert, 8 - Insert
            Insert = ABS(Insert - 1)
            LOCATE 19, 65, 0, 0, 0: PRINT Ins$(Insert);
            COLOR IVor, IHin
            EXIT SUB
       END SELECT
EDI10:

       SELECT CASE Zz$
         CASE "N"                         ' nur numerische Eingaben und Exp.
           SELECT CASE Isc
             CASE 32, 45, 46, 48 TO 57, 69, 101
               Z1$ = UCASE$(CHR$(Isc))
             CASE ELSE
               BEEP
               EXIT SUB
           END SELECT

        CASE "C"                          ' alfa - numerische Eingaben
          SELECT CASE Isc
             CASE 32 TO 126, 128 TO 254
               Z1$ = CHR$(Isc)
             CASE ELSE
               BEEP
               EXIT SUB
          END SELECT

        CASE "D"                          ' Dateiname
          SELECT CASE Isc
             CASE 48 TO 57, 65 TO 90, 97 TO 122
               Z1$ = UCASE$(CHR$(Isc))
             CASE ELSE
               BEEP
               EXIT SUB
          END SELECT

          CASE ELSE                       ' ... sonst kehre zurck
            EXIT SUB
       END SELECT

       IF Insert = 0 THEN                 ' Ueberschreiben
          MID$(Fld$, ICurs + 1) = Z1$
       ELSE                               ' Einfgen
          IF ICurs > 0 THEN
             Fld$ = MID$(Fld$, 1, ICurs) + Z1$ + MID$(Fld$, ICurs + 1)
          ELSE
             Fld$ = Z1$ + Fld$
          END IF
          Fld$ = MID$(Fld$, 1, ILen)
       END IF

       CALL MAX(ICurs, ILen - 1)

END SUB

SUB EXISTFILE (File$, Ext$, IFile)
SHARED IFin, IDir
      IDir = 0
      IFile = 0
      Pfad$ = File$ + Ext$
      CALL DIRECTORY(" ", Pfad$, 0, 0)
      IFile = IFin
END SUB


SUB FIRSTFILEN (Mask$, IFehl)
SHARED MaskSeg&, MaskOfs&, DTASeg&, DTAOfs&, FileN$(), IFin
SHARED Upro$
LOCAL I, IAbr, A$, C$

      Upro$ = "FIRSTFILEN"
      DEF SEG = MaskSeg&
      Mask$ = Mask$ + CHR$(0)
      FOR I = 1 TO LEN(Mask$)
          POKE I + MaskOfs& - 1, ASC(MID$(Mask$, I, 1))
      NEXT I
      DEF SEG
      REG 1, &H4E00
      REG 8, MaskSeg&
      REG 4, MaskOfs&
      REG 3, 1
      CALL INTERRUPT(&H21)
      IFehl = REG(1) AND &HFF
      I = 1
      A$ = ""
      DEF SEG = DTASeg&
      IAbr = 0
      IF IFehl = 0 THEN
      DO
        C$ = CHR$(PEEK(DTAOfs& + 29 + I))
        INCR I
        IF ((C$ >= " ") AND (C$ <= "z")) THEN
           IAbr = 0
        ELSE
           IAbr = 1
        END IF
        A$ = A$ + C$
      LOOP UNTIL IAbr = 1

      INCR IFin

      FileN$(IFin) = A$
      END IF
      DEF SEG

END SUB


SUB JANEIN (JN)
LOCAL JN$

     JN = 0
JN10:
     CALL PRESSKEY(JN$)
     SELECT CASE JN$
       CASE "J", CHR$(13)
         JN = 1
         EXIT SUB
       CASE "N"
         EXIT SUB
     END SELECT
     GOTO JN10

END SUB


SUB LINKS (Text$)
LIN10:
      IF LEFT$(Text$, 1) = CHR$(32) THEN
         Text$ = MID$(Text$, 2)
         GOTO LIN10
      END IF
END SUB

SUB LOESCHEN (Il, Ir, Io, Iu)
    CALL CHNGATT(Il, Ir, Io, Iu, 0)
END SUB

SUB MAX (IPos, Imax)
    INCR IPos
    IF IPos > Imax THEN IPos = Imax
END SUB

SUB MAXLEN (Text$, ILen)
LOCAL ITLen
    ITLen = LEN(Text$)
    IF ITLen < ILen THEN
       Text$ = Text$ + SPACE$(ILen - ITLen)
    ELSE
       Text$ = MID$(Text$, 1, ILen)
    END IF
END SUB

SUB MIN (IPos, Imin)
    DECR IPos
    IF IPos < Imin THEN IPos = Imin
END SUB

SUB NEXTFILEN (IFehl)
SHARED DTASeg&, DTAOfs&, FileN$(), IFin
SHARED Upro$
LOCAL I, IAbr, A$, C$

       Upro$ = "NEXTFILEN"
       WHILE IFehl = 0
       IFehl = 0
       REG 1, &H4F00
       REG 3, 22
       CALL INTERRUPT(&H21)
       IFehl = REG(1) AND &HFF
       A$ = ""
       I = 1
       DEF SEG = DTASeg&
     DO
       C$ = CHR$(PEEK(DTAOfs& + 29 + I))
       INCR I
       IF ((C$ >= " ") AND (C$ <= "z")) THEN
          IAbr = 0
       ELSE
          IAbr = 1
       END IF
       A$ = A$ + C$
     LOOP UNTIL IAbr = 1
     IF IFehl = 0 THEN
        INCR IFin
        FileN$(IFin) = A$
     END IF
     WEND
     DEF SEG
END SUB

SUB POSITION (IPos, IFeld, IHome, Iad)
      IPos = IPos + Iad
      IF IPos = IFeld + 1 THEN
         IPos = IHome
         EXIT SUB
      END IF
      IF IPos = IHome - 1 THEN IPos = IFeld
END SUB

SUB PRESSKEY (Tas$)
      DO
      LOOP UNTIL INSTAT
      Tas$ = UCASE$(INKEY$)
END SUB

SUB PUTSCREEN (Il, Ir, Io, Iu, Ib)
SHARED IZeich(), IAtt()
SHARED ISegFarbe, ISegOff
LOCAL IZpos, IPageS, I, J, IPosi

      DEF SEG = ISegFarbe
      IPageS = Ib * 2000
      FOR J = Io TO Iu
          IZpos = (J - 1) * 80 + IPageS + Il
          IPosi = ISegOff + (J - 1) * 160 + (Il - 1) * 2
          FOR I = Il TO Ir
              POKE IPosi, IZeich(IZpos)
              POKE IPosi + 1, IAtt(IZpos)
              INCR IZpos
              INCR IPosi, 2
          NEXT I
      NEXT J

END SUB

SUB RAHMEN (Il, Ir, Io, Iu, Ira, ILoesch)
SHARED IRahm()
       LOCATE Io, Il: PRINT CHR$(IRahm(1, Ira));
       LOCATE Io, Ir: PRINT CHR$(IRahm(2, Ira));
       LOCATE Iu, Ir: PRINT CHR$(IRahm(3, Ira));
       LOCATE Iu, Il: PRINT CHR$(IRahm(4, Ira));
       FOR II = Io + 1 TO Iu - 1
           FOR JJ = Il TO Ir STEP Ir - Il
               LOCATE II, JJ: PRINT CHR$(IRahm(5, Ira));
           NEXT JJ
       NEXT II
       LOCATE Iu, Il + 1: PRINT STRING$(Ir - Il - 1, IRahm(6, Ira));
       LOCATE Io, Il + 1: PRINT STRING$(Ir - Il - 1, IRahm(6, Ira));
       IF ILoesch = 1 THEN CALL CHNGATT(Il + 1, Ir - 1, Io + 1, Iu - 1, 0)
END SUB

SUB READFELD (IRow, ICol, ILen, D, Z$, Zz$, IRet)
SHARED Upro$, ICuSize, Insert, IVor, IHin, IGetHelp
LOCAL ICurs, Tas$, Isc1, Isc2, Isc3, ICMax, ZZZ$

'  Zz$  = C     alles
'  Zz$  = N     nur Zahlen, Dezimalpunkt und Vorzeichen
'  Zz$  = D     nur Zahlen und GROSSBUCHSTABEN

      Upro$ = "READFELD"
      ICurs = 0
      IVor = 8
      IHin = 7
      COLOR IVor, IHin
      ICMax = ILen - 1
      LOCATE IRow, ICol, 0, 0, 0
      PRINT SPACE$(ILen);
      LOCATE IRow, ICol, 1, ICuSize - (Insert * 3), ICuSize
      PRINT MID$(Z$, 1, ILen);
      CALL READSCREEN(IRow, ICol, ILen, Z$)

RF10:

      LOCATE IRow, ICol, 0, 0, 0
      PRINT Z$;
      IF IRet > 0 THEN
         LOCATE IRow, ICol + ICurs, 1, ICuSize - (Insert * 3), ICuSize
         Isc3 = IRet
         IRet = 0
         GOTO RF40
      END IF

RF20:
      LOCATE IRow, ICol + ICurs, 1, ICuSize - (Insert * 3), ICuSize
      DO
      LOOP UNTIL INSTAT
      Tas$ = INKEY$
      CALL SCAN(Tas$, Isc1, Isc2, Isc3)

RF40:
      SELECT CASE Isc3
        CASE 1072, 1080, 1073, 1081, 1116, 1115, 9, 1015
          IRet = Isc3
          GOTO RF30
        CASE 13, 27                       ' verlassen
          IRet = Isc3

RF30:
          ZZZ$ = Z$
          IF Zz$ = "N" THEN CALL DELBLK(ZZZ$)
          D = VAL(ZZZ$)
          IVor = 7
          IHin = 8
          COLOR IVor, IHin
          EXIT SUB
        CASE 8, 1075                      ' Cursor links
          CALL MIN(ICurs, 0)
        CASE 1077                         ' Cursor rechts
          CALL MAX(ICurs, ICMax)
        CASE 1071                         ' Cursor home
          ICurs = 0
        CASE 1079                         ' Cursor end
          ICurs = ICMax
        CASE 1059                         ' hole eventuell Hilfen
          IF IGetHelp = 1 THEN
             IGetHelp = 2
             EXIT SUB
          END IF
        CASE ELSE
           CALL EDITSCREEN(ILen, Z$, Isc3, Zz$, ICurs)
           GOTO RF10
      END SELECT
      GOTO RF20

END SUB

SUB READSCREEN (IRow, ICol, ILen, Z$)
SHARED Upro$
LOCAL I, IC, IR, Fld$

       Upro$ = "READSCREEN"
       IC = ICol
       Ir = IRow
       FOR I = 1 TO ILen
           Fld$ = Fld$ + CHR$(SCREEN(Ir, IC))
           INCR IC
       NEXT I
       Z$ = Fld$

END SUB


SUB RECHTS (Text$, Ile)
LOCAL IBLK

      CALL RDELBLK(Text$)
      IBLK = Ile - LEN(Text$)
      IF IBLK > 0 THEN Text$ = STRING$(IBLK, 32) + Text$

END SUB


SUB RDELBLK (Text$)
 
RDLB10:
      IF RIGHT$(Text$,1) = " " AND LEN(Text$) > 1 THEN
         Text$ = MID$(Text$, 1, LEN(Text$) - 1)
      ELSE 
         EXIT SUB
      END IF
      GOTO RDLB10
      
END SUB


SUB SAVESCREEN (Il, Ir, Io, Iu, Ib)
SHARED IZeich(), IAtt(), ISegFarbe, ISegOff
SHARED Upro$
LOCAL IZpos, IPageS, I, J, IPosi

      Upro$ = "SAVESCREEN"

      DEF SEG = ISegFarbe

      IPageS = Ib * 2000
      FOR J = Io TO Iu
          IZpos = (J - 1) * 80 + IPageS + Il
          IPosi = ISegOff + (J - 1) * 160 + (Il - 1) * 2
          FOR I = Il TO Ir
              IZeich(IZpos) = PEEK(IPosi)
              IAtt(IZpos) = PEEK(IPosi + 1)
              INCR IZpos
              INCR IPosi, 2
          NEXT I
      NEXT J

END SUB

SUB SCAN (Tas$, Isc1, Isc2, Isc3)
       Isc1 = 0
       Isc2 = 0
       Isc3 = 0
       IF LEN(Tas$) = 1 THEN
          Isc1 = ASC(LEFT$(Tas$, 1))
          Isc3 = Isc1
          EXIT SUB
       END IF
       Isc2 = ASC(RIGHT$(Tas$, 1))
       Isc3 = Isc2 + 1000
END SUB

SUB SCRNTYPE
SHARED ICuSize, ISegFarbe, ISegOff
LOCAL Karte
     
      DEF SEG = &H40
      Karte = PEEK(&H49)
      ICuSize = 7
      ISegFarbe = &HB000
      ISegOff = &H8000
      IF Karte = 7 THEN
         ICuSize = 13
         ISegFarbe = &HB000
         ISegOff = &H0
      END IF

END SUB

SUB SETDTA (IFehl)
SHARED DTASeg&, DTAOfs&
SHARED Upro$
      Upro$ = "SETDTA"
      REG 1, &H1A00
      REG 8, DTASeg&
      REG 4, DTAOfs&
      CALL INTERRUPT(&H21)
END SUB

SUB SETTEXT
SHARED H$(), B$(), ILoc(), IRahm()
SHARED Upro$
LOCAL I, J

      Upro$ = "SETTEXT"
      DIM IRahm(6, 2)
      FOR I = 1 TO 5                  ' Texte im Hauptmenue
          READ H$(I)
      NEXT I
      FOR I = 1 TO 5                  ' Positionen der Texte
          READ ILoc(I)
      NEXT I
      FOR I = 1 TO 22                 ' Texte des Konfigurationsmenues
          READ B$(I)
      NEXT I
      FOR J = 1 TO 2                  ' Rahmen - Varianten
          FOR I = 1 TO 6
              READ IRahm(I, J)
          NEXT I
      NEXT J

END SUB


SUB SPEICHERFREI
SHARED Upro$
LOCAL Form$

       Upro$ = "SPEICHERFREI"
       Form$ = "######"
       CALL SAVESCREEN(25, 51, 12, 19, 3)
       COLOR 15, 8
       CALL RAHMEN(25, 51, 12, 19, 2, 1)
       LOCATE 13, 27, 0, 0, 0
       COLOR 8, 7
       PRINT "freier Speicher:";
       LOCATE 15, 27
       COLOR 7, 8
       PRINT "Arrays:"; TAB(43);
       PRINT USING Form$; FRE(-1);
       LOCATE 16, 27
       PRINT "Strings:"; TAB(43);
       PRINT USING Form$; FRE("A") + 10
       LOCATE 17, 27
       PRINT "Stack:"; TAB(43);
       PRINT USING Form$; FRE(-2);
       LOCATE 18, 27
       PRINT "gesamt frei:"; TAB(43);
       PRINT USING Form$; FRE(-1) + FRE(-2) + FRE("A") + 10;
       CALL PRESSKEY("")
       CALL PUTSCREEN(25, 51, 12, 19, 3)

END SUB


SUB TEXTBOX (Io, Il, Iss, Text$, Ret$)
SHARED Upro$
LOCAL Ir

      Upro$ = "TEXTBOX"
      Ir = Il + LEN(Text$) + 4
      CALL SAVESCREEN(Il, Ir, Io, Io + 2, Iss)
      COLOR 8, 7
      CALL RAHMEN(Il, Ir, Io, Io + 2, 2, 1)
      COLOR 7, 8
      LOCATE Io + 1, Il + 2, 0, 0, 0
      PRINT Text$;
      CALL WARTE(15, Ret$)
      CALL PUTSCREEN(Il, Ir, Io, Io + 2, Iss)

END SUB

SUB WARTE (Dauer, Taste$)
LOCAL Zeit1, Zeit2
 
     Zeit1 = TIMER
WAR10:
     Zeit2 = TIMER
     Taste$ = UCASE$(INKEY$)
     IF Zeit2 - Zeit1 < Dauer AND Taste$ = "" THEN WAR10

END SUB

